<ng-container *transloco="let t; prefix: translocoPrefix()">

  @if (filterGroup(); as filters) {
  <lib-filter [filters]="filters" (submit)="onFilterSubmit($event)"></lib-filter>
  }

  <table mat-table [dataSource]="offlinePaginator() ? this.paginatedRows.content : rows()" matSort (matSortChange)="onSortChange($event)">
    <!-- status -->
    @for (column of columns(); track column) {
    <ng-container [matColumnDef]="column.def">

      @if(isCheckbox(column)) {
      <th data-testid="select-all-element" mat-header-cell *matHeaderCellDef>
        <mat-checkbox (click)="$event.stopPropagation()" (keydown.enter)="$event.stopPropagation();" (change)="toggleAllRows()"
          [checked]="checkboxSelection.hasValue() && isAllSelected()"
          [indeterminate]="checkboxSelection.hasValue() && !isAllSelected()"
        [disabled]="disabledCheckbox">
        </mat-checkbox>
      </th>
      <td data-testid="select-element" mat-cell *matCellDef="let row">
        <mat-checkbox (click)="$event.stopPropagation()" (keydown.enter)="$event.stopPropagation();" (change)="allDataRow() ? handleChangeRowCheckbox(row)  : handleChangeRowCheckbox(row?.[paramToUse()])"
          [checked]="allDataRow() ? checkboxSelection.isSelected(row) :  checkboxSelection.isSelected(row?.[paramToUse()])" [disabled]="disabledCheckbox">
        </mat-checkbox>
      </td>
      } @else {
      <th mat-header-cell *matHeaderCellDef class="text-uppercase" mat-sort-header [disabled]="!column.sort"> {{
        t(column.header) }}</th>
      <td data-testid="element" mat-cell *matCellDef="let element">
        @if(isBadge(element[column.key])) {
        <span data-testid="badge-element" [class]="'bg-' + element[column.key].type" class="badge p-2">{{ element[column.key].text |
          removeUnderscore
          }}</span>
        } @else if (isDate(element[column.key])) {
        <span data-testid="date-element">{{element[column.key] | date}}</span>
        } @else {
        <span data-testid="text-element" [ngClass]="column?.classes ?? {}">{{element[column.key] | removePlaceholderTemp}}</span>
        }
        @if (isButtonAction(element[column.key]); as buttons) {
        <div data-testid="button-element-group" class="d-flex">
          @for (button of buttons; track button) {
          <button data-testid="button-element" class="btn btn-sm d-flex p-1 me-1" type="button"
            [class]="(button.color ? 'bg-' + button.color : '') + ' ' + (button.theme ? 'btn-' + button.theme : '')"
            (click)="$event.stopPropagation(); button.action(element)">
            <mat-icon data-testid="btn-icon" *ngIf="button.icon">{{button.icon}}</mat-icon>@if(button.label) { {{ t(button.label) }} }
          </button>
          }
        </div>
        }
      </td>
      }
    </ng-container>
    }

    <tr mat-header-row *matHeaderRowDef="displayedColumns()"></tr>
    <tr mat-row *matRowDef="let element; columns: displayedColumns();" [class.clickable]="clickable()"
      (click)="rowAction.emit(element)" (keydown.enter)="rowAction.emit(element)"></tr>
  </table>

  @if (loading()) {
  <div class="w-full d-flex items-center justify-content-center py-5">
    <lib-loader [size]=80></lib-loader>
  </div>
  }

  @if (!rows() || (rows().length === 0 && !loading())) {
  <div class="p-5 text-center"> {{ t('empty') }}</div>
  }

  <div data-testid="pagination">
    @if (offlinePaginator()) {
      <mat-paginator #offlinePaginatorElement
                     [pageSizeOptions]="[5, 10, 25, 100]"
                     [length]="localDataSource.content.length"
                     [pageSize]="pageSize()"
                     [pageIndex]="currentPage()"
                     (page)="onPageChange($event)">
      </mat-paginator>
    } @else {
      <mat-paginator [length]="totalElements()" [pageSize]="pageSize()" [pageSizeOptions]="[5, 10, 25, 100]"
                     [pageIndex]="currentPage()" (page)="onPageChange($event)"></mat-paginator>
    }
  </div>


</ng-container>
